import QtQuick 1.0

Rectangle {
    id: aboutMenuPanel

    property string playButtonImage: "MEDIA/GFX/menu/startNewGameButton.png"

    x:parent.width/2-250
    y:parent.height/2-200
    z:100

    width: 500
    height: 400

    opacity: 0.9
    color: "#404040"
    radius: 10
    visible: true
    border.color: "black"

    Gradient {
        id: gradientStandart
        GradientStop { position: 0.0; color: "#707070" }
        GradientStop { position: 0.2; color: "#606060" }
        GradientStop { position: 0.9;color: "#303030" }
        GradientStop { position: 1.0; color: "#202020" }
    }

    Gradient {
        id: gradientPressed
        GradientStop { position: 0.0; color: "#202020" }
        GradientStop { position: 0.2;color: "#303030" }
        GradientStop { position: 0.9; color: "#606060" }
        GradientStop { position: 1.0; color: "#707070" }
    }

    Text{
        id: titleLabel
        x: parent.width/2-width/2
        anchors.top: parent.top
        anchors.margins: 10

        color: "white"
        font.pixelSize: 40
        text: "About us: "
    }

    Text{
        id: devLabel
        y: titleLabel.y+80
        anchors.left: parent.left
        anchors.leftMargin: 10

        color: "white"
        font.pixelSize: 30
        text: "Development:"
    }

    Text{
        id: devNameLabel
        y: titleLabel.y+80
        x: 200

        color: "white"
        font.pixelSize: 30
        text: "Alexander Ostapenko"
    }



    Text{
        id: designLabel
        anchors.top: devLabel.bottom
        anchors.left: parent.left
        anchors.margins: 10

        color: "white"
        font.pixelSize: 30
        text: "Design:"
    }

    Text{
        id: designNameLabel
        anchors.top: devNameLabel.bottom
        x: 200
        anchors.margins: 10

        color: "white"
        font.pixelSize: 30
        text: "Vladislav Nedviga"
    }



    Text{
        id: musicLabel
        anchors.top: designLabel.bottom
        anchors.left: parent.left
        anchors.margins: 10

        color: "white"
        font.pixelSize: 30
        text: "Music:"
    }

    Text{
        id: musicNameLabel
        anchors.top: designNameLabel.bottom
        x: 200
        anchors.margins: 10

        color: "white"
        font.pixelSize: 30
        text: "Danil Aleynikov"
    }



    Text{
        id: animationLabel
        anchors.top: musicLabel.bottom
        anchors.left: parent.left
        anchors.margins: 10

        color: "white"
        font.pixelSize: 30
        text: "Animation:"
    }

    Text{
        id: animationNameLabel
        anchors.top: musicNameLabel.bottom
        x: 200
        anchors.margins: 10

        color: "white"
        font.pixelSize: 30
        text: "Margarita Faizullina"
    }



    Rectangle{
        id: resumeButton
        x: parent.width/2-width/2
        z: parent.z+1
        width: 330
        height: 55
        anchors.bottom: parent.bottom
        anchors.margins: 30
        visible: true
        radius: 10

        Image{
            source: "MEDIA/GFX/menu/exitButton.png"
            anchors.centerIn: parent
            z: parent.z+2
        }

        border.color: "black"
        gradient: gradientStandart

        MouseArea{
            anchors.fill:parent
            anchors.bottom: parent.bottom
            width:parent.width
            height: parent.height

            onPressed: resumeButton.gradient=gradientPressed
            onReleased: resumeButton.gradient=gradientStandart
            onClicked: {
                aboutMenu.visible=false
                startMenu.visible=true
            }
        }
    }
}
