import QtQuick 1.0
import FileIO 1.0

Rectangle {
    id: mainMenuPanel

    x:parent.width/2-250
    y:parent.height/2-200
    z:100

    width: 500
    height: 400

    opacity: 0.9
    color: "#404040"
    radius: 10
    visible: false
    border.color: "black"

    Image{
        x: parent.width/2-width/2
        y: 10
        z: parent.z+1
        source: "MEDIA/GFX/menu/completedImage.png"
    }


    Text{
        x: 20
        y: 80
        color: "white"
        font.pixelSize: 30
        text: "Monster killed: "
    }

    Text{
        x: 380
        y: 80
        color: "white"
        font.pixelSize: 30
        text: gameStatistic.kill
    }




    Text{
        x: 20
        y: 120
        color: "white"
        font.pixelSize: 30
        text: "Monster missed: "
    }

    Text{
        x: 380
        y: 120
        color: "white"
        font.pixelSize: 30
        text: gameStatistic.miss
    }



    Text{
        x: 20
        y: 160
        color: "white"
        font.pixelSize: 30
        text: "Level score: "
    }

    Text{
        x: 380
        y: 160
        color: "white"
        font.pixelSize: 30
        text: gameStatistic.levelScore
    }


    Text{
        x: 20
        y: 200
        color: "white"
        font.pixelSize: 30
        text: "Bullet Bonus:      "+gameStatistic.bullet+" * 10 = "
    }

    Text{
        x: 380
        y: 200
        color: "white"
        font.pixelSize: 30
        text: gameStatistic.bullet*10
    }


    Text{
        x: 20
        y: 210
        color: "white"
        font.pixelSize: 30
        text: "_____________________________"
    }


    Text{
        x: 20
        y: 270
        color: "white"
        font.pixelSize: 30
        text: "Total score"
    }

    Text{
        x: 380
        y: 270
        color: "white"
        font.pixelSize: 30
        text: gameStatistic.score+gameStatistic.levelScore+gameStatistic.bullet*10
    }


    Rectangle{
        id: nextLevelButton
        x: parent.width/2-width/2
        y: parent.height-20-55
        z: parent.z+1
        width: 330
        height: 55
        visible: parent.visible
        radius: 10

        Image{
            source: "MEDIA/GFX/menu/okButton.png"
            anchors.centerIn: parent
            z: parent.z+2
        }

        border.color: "black"
        gradient: gradientStandart

        Gradient {
            id: gradientStandart
            GradientStop { position: 0.0; color: "#707070" }
            GradientStop { position: 0.2; color: "#606060" }
            GradientStop { position: 0.9;color: "#303030" }
            GradientStop { position: 1.0; color: "#202020" }
        }

        Gradient {
            id: gradientPressed
            GradientStop { position: 0.0; color: "#202020" }
            GradientStop { position: 0.2;color: "#303030" }
            GradientStop { position: 0.9; color: "#606060" }
            GradientStop { position: 1.0; color: "#707070" }
        }

        MouseArea{
            anchors.fill:parent
            anchors.bottom: parent.bottom
            width:parent.width
            height: parent.height

            onPressed: nextLevelButton.gradient=gradientPressed
            onReleased: nextLevelButton.gradient=gradientStandart
            onClicked: {
                var temp = gameStatistic.levelPassed
                temp[gameStatistic.levelAndMode]=true
                gameStatistic.levelPassed=temp

                var temp2 = gameStatistic.levelHighScores
                temp2[gameStatistic.levelAndMode]=gameStatistic.levelScore
                gameStatistic.levelHighScores=temp2

                if(gameStatistic.levelAndMode<20) {
                    if (gameStatistic.mode<3){
                        var temp3 = gameStatistic.levelUnlocked
                        temp3[gameStatistic.levelAndMode+1]=true
                        gameStatistic.levelUnlocked=temp3
                    }
                }

                gameStatistic.score=gameStatistic.score+gameStatistic.levelScore+gameStatistic.bullet*10

                saveProgress();
                newLevelMenu.visible=false
                selectLevelMenu.visible=true
            }
        }
    }

    FileIO {
        id: confFile
        source: iniFilePath
        onError: console.log(msg)
    }

    function saveProgress(){
        confFile.writeLine("[Total score]");
        confFile.appendLine(gameStatistic.score);
        confFile.appendLine("");
        console.log("[Total score]");
        console.log(gameStatistic.score);
        for (var i=0; i<21; i++){
            confFile.appendLine(gameStatistic.levelUnlocked[i]);
            confFile.appendLine(gameStatistic.levelPassed[i]);
            confFile.appendLine(gameStatistic.levelHighScores[i]);
        }
    }
}
