import QtQuick 1.1
import Qt 4.7
import com.nokia.meego 1.0
import QtMultimediaKit 1.1
import FileIO 1.0

Page {
    id: mainPage
    property bool blackDuckNeeded: true
    property bool brownDuckNeeded: true
    property bool greenDuckNeeded: true
    property string initialDuck: "NULL"
    property int duckMaxLifeTime: 10000

    property bool initializationFlag: true
    property bool gameStarted: false
    property bool paused: true
    //property string frameRate: ""
    property int soundVolume: 1.0;

    //property string iniFilePath: "WhatTheDuckConf.ini"
    property string iniFilePath: "/home/user/WhatTheDuckConf.ini"
    orientationLock: PageOrientation.LockLandscape

    Keys.onVolumeDownPressed:{if (soundVolume>0.0) soundVolume=-0.1}
    Keys.onVolumeUpPressed:  {if (soundVolume<1.0) soundVolume=+0.1}

    Rectangle {
        id:gameScreen
        x:0
        y:0
        width: parent.width
        height: parent.height
        //anchors.fill: parent
        z:0
        clip: true

        Statistics{
            id: gameStatistic
            x: 0
            y: 420
            z: 100
            width: gameScreen.width-80
            height: 60
            visible: false
        }

        states:[
            State {
                name: "LEVEL1"
                PropertyChanges { target: backGround; source: "MEDIA/GFX/background.png"}
                PropertyChanges { target: grass; y: 380}
                PropertyChanges { target: grass; source: "MEDIA/GFX/grass0.png"}
                PropertyChanges { target: tree; visible: true}
                PropertyChanges { target: flash; visible: false}
                PropertyChanges { target: cloud1; sourcePath: "MEDIA/GFX/clouds.png"}
            },
            State {
                name: "LEVEL2"
                PropertyChanges { target: backGround; source: "MEDIA/GFX/background2.png"}
                PropertyChanges { target: grass; source: "MEDIA/GFX/grass02.png"}
                PropertyChanges { target: grass; y: 125}
                PropertyChanges { target: tree; visible: false}
                PropertyChanges { target: cloud1; sourcePath: "MEDIA/GFX/clouds2.png"}
                PropertyChanges { target: flash; x: 554}
                PropertyChanges { target: flash; y: 124}
                PropertyChanges { target: flash; source: "MEDIA/GFX/flash.png"}
            },
            State {
                name: "LEVEL3"
                PropertyChanges { target: backGround; source: "MEDIA/GFX/background3.png"}
                PropertyChanges { target: grass; source: "MEDIA/GFX/grass03.png"}
                PropertyChanges { target: grass; y: 0}
                PropertyChanges { target: tree; visible: false}
                PropertyChanges { target: cloud1; sourcePath: "MEDIA/GFX/clouds3.png"}
                PropertyChanges { target: flash; x: 0}
                PropertyChanges { target: flash; y: 0}
                PropertyChanges { target: flash; source: "MEDIA/GFX/flash3.png"}
            },
            State {
                name: "LEVEL4"
                PropertyChanges { target: backGround; source: "MEDIA/GFX/background4.png"}
                PropertyChanges { target: grass; source: "MEDIA/GFX/grass04.png"}
                PropertyChanges { target: grass; y: 55}
                PropertyChanges { target: tree; visible: false}
                PropertyChanges { target: cloud1; sourcePath: "MEDIA/GFX/clouds4.png"}
                PropertyChanges { target: flash; x: 0}
                PropertyChanges { target: flash; y: 70}
                PropertyChanges { target: flash; source: "MEDIA/GFX/flash4.png"}
            },
            State {
                name: "LEVEL5"
                PropertyChanges { target: backGround; source: "MEDIA/GFX/background5.png"}
                PropertyChanges { target: grass; source: "MEDIA/GFX/grass05.png"}
                PropertyChanges { target: grass; y: 80}
                PropertyChanges { target: tree; visible: false}
                PropertyChanges { target: cloud1; sourcePath: "MEDIA/GFX/clouds5.png"}
                PropertyChanges { target: flash; x: 0}
                PropertyChanges { target: flash; y: 70}
                PropertyChanges { target: flash; source: "MEDIA/GFX/flash5.png"}
            },
            State {
                name: "LEVEL6"
                PropertyChanges { target: backGround; source: "MEDIA/GFX/background6.png"}
                PropertyChanges { target: grass; source: "MEDIA/GFX/grass06.png"}
                PropertyChanges { target: grass; y: 190}
                PropertyChanges { target: tree; visible: false}
                PropertyChanges { target: cloud1; sourcePath: "MEDIA/GFX/clouds6.png"}
                PropertyChanges { target: flash; x: 145}
                PropertyChanges { target: flash; y: 158}
                PropertyChanges { target: flash; source: "MEDIA/GFX/flash6.png"}
            },
            State {
                name: "LEVEL7"
                PropertyChanges { target: backGround; source: "MEDIA/GFX/background7.png"}
                PropertyChanges { target: grass; source: "MEDIA/GFX/grass07.png"}
                PropertyChanges { target: grass; y: 157}
                PropertyChanges { target: tree; visible: false}
                PropertyChanges { target: cloud1; sourcePath: "MEDIA/GFX/clouds7.png"}
                PropertyChanges { target: flash; x: 430}
                PropertyChanges { target: flash; y: 120}
                PropertyChanges { target: flash; source: "MEDIA/GFX/flash7.png"}
            }
        ]

        StartMenu{
            id:startMenu
            visible: false
        }

        AboutMenu{
            id:aboutMenu
            visible: false
        }

        SelectLevelMenu{
            id:selectLevelMenu
            visible: false
        }

        Audio  {
            id: newYorkTheme
            autoLoad: true

            //loops: 10
            volume: soundVolume
            source:"MEDIA/SND/newYorkTheme.mp3"
        }

        Audio  {
            id: goldenGateTheme
            autoLoad: false
            //loops: 10
            volume: soundVolume
            source:"MEDIA/SND/goldenGateTheme.mp3"
        }

        Audio  {
            id: parisTheme
            autoLoad: false
            //loops: 10
            volume: soundVolume
            source:"MEDIA/SND/parisTheme.mp3"
        }

        Audio  {
            id: moscowTheme
            autoLoad: false
            //loops: 10
            volume: soundVolume
            source:"MEDIA/SND/moscowTheme.mp3"
        }

        Audio  {
            id: chernobilTheme
            autoLoad: false
            //loops: 10
            volume: soundVolume
            source:"MEDIA/SND/chernobilTheme.mp3"
        }

        Audio  {
            id: egyptTheme
            autoLoad: false
            //loops: 10
            volume: soundVolume
            source:"MEDIA/SND/egyptTheme.mp3"
        }

        Audio  {
            id: chinaTheme
            autoLoad: false
            //loops: 10
            volume: soundVolume
            source:"MEDIA/SND/chinaTheme.mp3"
        }


        Image{
            id:backGround
            anchors.fill: parent
            z:1
            source:"MEDIA/GFX/background.png"
            clip: true
        }

        Image{
            id:tree
            x:20
            y:0
            z:10
            source:"MEDIA/GFX/tree.png"
            clip: true
        }

        Image{
            id:flash
            x:552
            y:124
            z:20
            source:"MEDIA/GFX/flash.png"
            clip: true
            visible: false
        }

        Image{
            id:grass
            x:0
            y:380
            z:9
            source:"MEDIA/GFX/grass0.png"
            clip: true
        }

        Clouds{
            id:cloud1
            sourcePath:"MEDIA/GFX/clouds.png"

            epsilon:10

            animationSpeed:140
            speed:2

            x:0
            y:-60
            prevX:5
            prevY:-60
            targetX: -860
            targetY: -60
            z:2

            lifeTime: 0
        }

        Clouds{
            id:cloud2
            sourcePath:cloud1.sourcePath

            epsilon:10

            animationSpeed:120
            speed:2

            x:854
            y:cloud1.y
            prevX:855
            prevY:cloud1.prevY
            targetX: -860
            targetY: cloud1.targetY
            z: cloud1.z

            lifeTime: 0
        }

        Clouds{
            id:cloud3
            sourcePath:cloud1.sourcePath

            epsilon:10

            animationSpeed:40
            speed:2

            x:0
            y:20
            prevX:5
            prevY:20
            targetX: -860
            targetY:20
            z:3

            lifeTime: 0
        }

        Clouds{
            id:cloud4
            sourcePath:cloud1.sourcePath

            epsilon:10

            animationSpeed:40
            speed:2

            x:854
            y:cloud3.y
            prevX:855
            prevY:cloud3.prevY
            targetX: -860
            targetY: cloud3.targetY
            z: cloud3.z

            lifeTime: 0
        }



        AnimatedSprite{
            id:blackDuck

            epsilon:10

            framesHorizontCount:6
            framesVerticalCount:4
            framesCount:(framesHorizontCount*framesVerticalCount)
            currentFrame:-1
            sourcePath:"MEDIA/GFX/BlackDuck.png"
            animationSpeed:100
            speed:5

            x:200
            y:360
            prevX:398
            prevY:362
            targetX: 10+Math.random()*800
            targetY: 10+Math.random()*350
            z:3

            lifeTime: 0
            flyAway: false
        }

        AnimatedSprite{
            id:brownDuck

            epsilon:10

            framesHorizontCount:6
            framesVerticalCount:4
            framesCount:(framesHorizontCount*framesVerticalCount)
            currentFrame:-1
            sourcePath:"MEDIA/GFX/BrownDuck.png"
            animationSpeed:100
            speed:5

            x:600
            y:360
            prevX:398
            prevY:362
            targetX: 10+Math.random()*800
            targetY: 10+Math.random()*350
            z:5

            lifeTime: 0
            flyAway: false
        }

        AnimatedSprite{
            id:greenDuck

            epsilon:10

            framesHorizontCount:6
            framesVerticalCount:4
            framesCount:(framesHorizontCount*framesVerticalCount)
            currentFrame:-1
            sourcePath:"MEDIA/GFX/BrownDuck.png"
            animationSpeed:100
            speed:5

            x:600
            y:360
            prevX:398
            prevY:362
            targetX: 10+Math.random()*800
            targetY: 10+Math.random()*350
            z:5

            lifeTime: 0
            flyAway: false
        }

        DogAnimation{
            id:dog

            epsilon:0

            framesHorizontCount:5
            framesVerticalCount:3
            framesCount:(framesHorizontCount*framesVerticalCount)
            currentFrame:-1
            sourcePath:"MEDIA/GFX/dog.png"
            animationSpeed:150
            speed:4

            x:1
            y:250
            prevX:0
            prevY:250
            targetX: 200
            targetY: 250
            z:100

            state:"START_LEVEL"
        }

        FeathersSprite{
            id:feathers1

            epsilon:0

            framesHorizontCount:5
            framesVerticalCount:1
            framesCount:(framesHorizontCount*framesVerticalCount)
            currentFrame:-1
            sourcePath:"MEDIA/GFX/feathers.png"
            animationSpeed:75
            speed:3
            visible:false

            x:1000
            y:1000
            prevX:0
            prevY:0
            targetX: 0
            targetY: 0
            z:4

            opacity: 1

            state:"START"
        }

        FeathersSprite{
            id:feathers2

            epsilon:0

            framesHorizontCount:5
            framesVerticalCount:1
            framesCount:(framesHorizontCount*framesVerticalCount)
            currentFrame:-1
            sourcePath:"MEDIA/GFX/feathers.png"
            animationSpeed:75
            speed:3
            visible:false

            x:1000
            y:1000
            prevX:0
            prevY:0
            targetX: 0
            targetY: 0
            z:4

            opacity: 1

            state:"START"
        }

        FeathersSprite{
            id:feathers3

            epsilon:0

            framesHorizontCount:5
            framesVerticalCount:1
            framesCount:(framesHorizontCount*framesVerticalCount)
            currentFrame:-1
            sourcePath:"MEDIA/GFX/feathers.png"
            animationSpeed:75
            speed:3
            visible:false

            x:1000
            y:1000
            prevX:0
            prevY:0
            targetX: 0
            targetY: 0
            z:4

            opacity: 1

            state:"START"
        }

        AnimatedSprite{
            id:shot

            framesHorizontCount:16
            framesVerticalCount:1
            framesCount:(framesHorizontCount*framesVerticalCount)
            currentFrame:-1
            sourcePath: "MEDIA/GFX/shot.png"
            animationSpeed:10

            x:1000
            y:1000
            z:3
        }

        Timer{
            id:cloudTimer
            interval:cloud1.animationSpeed
            running:true
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    cloud1.x+=Math.ceil(((cloud1.targetX-cloud1.x)/Math.abs(cloud1.targetX-cloud1.x))*cloud1.speed)
                    cloud2.x+=Math.ceil(((cloud2.targetX-cloud2.x)/Math.abs(cloud2.targetX-cloud2.x))*cloud2.speed)

                    if (cloud1.x<=-854) cloud1.x=854
                    if (cloud2.x<=-854) cloud2.x=854
                }
            }
        }

        Timer{
            id:cloudTimer2
            interval:cloud3.animationSpeed
            running:true
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    cloud3.x+=Math.ceil(((cloud3.targetX-cloud3.x)/Math.abs(cloud3.targetX-cloud3.x))*cloud3.speed)
                    cloud4.x+=Math.ceil(((cloud4.targetX-cloud4.x)/Math.abs(cloud4.targetX-cloud4.x))*cloud4.speed)

                    if (cloud3.x<=-854) cloud3.x=854
                    if (cloud4.x<=-854) cloud4.x=854
                }
            }
        }

        Timer{
            id:flashTimer
            interval: 200
            running:false
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    if (gameScreen.state=="LEVEL2") {if (Math.random()>0.5) {flash.source="MEDIA/GFX/flash0.png"} else {flash.source="MEDIA/GFX/flash.png"}}
                    else  if (gameScreen.state=="LEVEL3") {if (Math.random()>0.5) {flash.source="MEDIA/GFX/flash03.png"} else {flash.source="MEDIA/GFX/flash3.png"}}
                    else  if (gameScreen.state=="LEVEL4") {if (Math.random()>0.5) {flash.source="MEDIA/GFX/flash04.png"} else {flash.source="MEDIA/GFX/flash4.png"}}
                    else  if (gameScreen.state=="LEVEL5") {if (Math.random()>0.5) {flash.source="MEDIA/GFX/flash05.png"} else {flash.source="MEDIA/GFX/flash5.png"}}
                    else  if (gameScreen.state=="LEVEL6") {if (Math.random()>0.5) {flash.source="MEDIA/GFX/flash06.png"} else {flash.source="MEDIA/GFX/flash6.png"}}
                    else {if (Math.random()>0.5) {flash.source="MEDIA/GFX/flash07.png"} else {flash.source="MEDIA/GFX/flash7.png"}}
                    interval=1+Math.random()*100
                }
            }
        }

        Timer{
            id:featherTimer
            interval:feathers1.animationSpeed
            running:false
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    feathers1.y+=Math.ceil(((feathers1.targetY-feathers1.y)/Math.abs(feathers1.targetY-feathers1.y))*feathers1.speed)

                    if (feathers1.y>=500){
                        featherTimer.stop()
                        feathers1.visible=false
                    }

                    if (feathers1.opacity<=0){
                        featherTimer.stop()
                        feathers1.visible=false
                    }

                    if ((feathers1.state=="START")&&(feathers1.currentFrame==feathers1.endFrame)){
                        feathers1.state="CYCLE"
                    }


                    if (feathers1.currentFrame==feathers1.endFrame){
                        feathers1.currentFrame=feathers1.startFrame
                    } else {
                        feathers1.currentFrame++
                        feathers1.opacity-=0.02
                    }
                }
            }
        }

        Timer{
            id:featherTimer2
            interval:feathers2.animationSpeed
            running:false
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    feathers2.y+=Math.ceil(((feathers2.targetY-feathers2.y)/Math.abs(feathers2.targetY-feathers2.y))*feathers2.speed)

                    if (feathers2.y>=500){
                        featherTimer2.stop()
                        feathers2.visible=false
                    }

                    if (feathers2.opacity<=0){
                        featherTimer2.stop()
                        feathers2.visible=false
                    }

                    if ((feathers2.state=="START")&&(feathers2.currentFrame==feathers2.endFrame)){
                        feathers2.state="CYCLE"
                    }


                    if (feathers2.currentFrame==feathers2.endFrame){
                        feathers2.currentFrame=feathers2.startFrame
                    } else {
                        feathers2.currentFrame++
                        feathers2.opacity-=0.02
                    }
                }
            }
        }

        Timer{
            id:featherTimer3
            interval:feathers3.animationSpeed
            running:false
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    feathers3.y+=Math.ceil(((feathers3.targetY-feathers3.y)/Math.abs(feathers3.targetY-feathers3.y))*feathers3.speed)

                    if (feathers3.y>=500){
                        featherTimer3.stop()
                        feathers3.visible=false
                    }

                    if (feathers3.opacity<=0){
                        featherTimer3.stop()
                        feathers2.visible=false
                    }

                    if ((feathers3.state=="START")&&(feathers3.currentFrame==feathers3.endFrame)){
                        feathers3.state="CYCLE"
                    }


                    if (feathers3.currentFrame==feathers3.endFrame){
                        feathers3.currentFrame=feathers3.startFrame
                    } else {
                        feathers3.currentFrame++
                        feathers3.opacity-=0.02
                    }
                }
            }
        }

        Timer{
            id:dogTimer
            interval:dog.animationSpeed
            running:false
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    dog.prevX=dog.x
                    dog.prevY=dog.y

                    if (dog.state!="CATCH") dog.x+=Math.ceil(((dog.targetX-dog.x)/Math.abs(dog.targetX-dog.x))*dog.speed)
                    dog.y+=Math.ceil(((dog.targetY-dog.y)/Math.abs(dog.targetY-dog.y))*dog.speed)

                    if (dog.state=="CATCH") {
                        if (dog.y<=280){
                            dog.y+=dog.speed
                            dog.targetY=400
                        }
                        if (dog.y>=380){
                            dog.y=500
                            if (initialDuck=="BLACK_DUCK") blackDuckNeeded=true
                            if (initialDuck=="BROWN_DUCK") brownDuckNeeded=true
                            if (initialDuck=="GREEN_DUCK") greenDuckNeeded=true
                            dogTimer.stop()
                        }
                    } else if (dog.state=="MISS") {
                        if (dog.y<=270){
                            dog.y+=dog.speed
                            dog.targetY=400
                        }
                        if (dog.y>=380){
                            dog.y=500
                            if (initialDuck=="BLACK_DUCK") blackDuckNeeded=true;
                            if (initialDuck=="BROWN_DUCK") brownDuckNeeded=true;
                            if (initialDuck=="GREEN_DUCK") greenDuckNeeded=true;
                            dogTimer.stop()
                        }
                    } else if (dog.state=="START_LEVEL"){
                        if (dog.x>=200){
                            dog.y=310
                            dog.targetX=240
                            dog.targetY=270
                            dog.animationSpeed=150
                            dog.state="JUMP"
                            dog.currentFrame=dog.startFrame
                            dog.z=10
                            chienSaute.play()
                        }
                    }else if (dog.state=="JUMP"){
                        if (dog.y<=270){
                            dog.y=500
                            dog.animationSpeed=10
                            dog.z=3

                            if (gameScreen.state=="LEVEL1"){
                                grass.source="MEDIA/GFX/grass.png"
                            }
                            else if (gameScreen.state=="LEVEL2"){
                                grass.source="MEDIA/GFX/grass2.png"
                                flash.visible=true
                                flashTimer.running=true
                            }
                            else if (gameScreen.state=="LEVEL3"){
                                grass.source="MEDIA/GFX/grass3.png"
                                flash.visible=true
                                flashTimer.running=true
                            }
                            else if (gameScreen.state=="LEVEL4"){
                                grass.source="MEDIA/GFX/grass4.png"
                                flash.visible=true
                                flashTimer.running=true
                            }
                            else if (gameScreen.state=="LEVEL5"){
                                grass.source="MEDIA/GFX/grass5.png"
                                flash.visible=true
                                flashTimer.running=true
                            }
                            else if (gameScreen.state=="LEVEL6"){
                                grass.source="MEDIA/GFX/grass6.png"
                                flash.visible=true
                                flashTimer.running=true
                            }
                            else if (gameScreen.state=="LEVEL7"){
                                grass.source="MEDIA/GFX/grass7.png"
                                flash.visible=true
                                flashTimer.running=true
                            }

                            gameStatistic.visible=true

                            if ((gameStatistic.mode==1)||(gameStatistic.mode==2)||(gameStatistic.mode==3)) blackDuckTimer.start()
                            if ((gameStatistic.mode==2)||(gameStatistic.mode==3))brownDuckTimer.start()
                            if ((gameStatistic.mode==3))greenDuckTimer.start()

                            dogTimer.stop()

                            if ((gameStatistic.mode==1)||(gameStatistic.mode==2)||(gameStatistic.mode==3)) blackDuck.visible=true
                            if ((gameStatistic.mode==2)||(gameStatistic.mode==3)) brownDuck.visible=true
                            if ((gameStatistic.mode==3)) greenDuck.visible=true

                            duckFlightSound.play()

                            gameStatistic.total=gameStatistic.total-gameStatistic.mode
                        }
                    }

                    if (dog.currentFrame==dog.endFrame){
                        if (dog.state!="JUMP") dog.currentFrame=dog.startFrame
                    } else {
                        dog.currentFrame++
                    }
                }
            }
        }

        Timer{
            id:blackDuckTimer
            interval:blackDuck.animationSpeed
            running:false
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    blackDuck.prevX=blackDuck.x
                    blackDuck.prevY=blackDuck.y

                    blackDuck.x+=Math.ceil(((blackDuck.targetX-blackDuck.x)/Math.abs(blackDuck.targetX-blackDuck.x))*blackDuck.speed)
                    blackDuck.y+=Math.ceil(((blackDuck.targetY-blackDuck.y)/Math.abs(blackDuck.targetY-blackDuck.y))*blackDuck.speed)

                    if ((blackDuck.state!="DEAD")&&(blackDuck.flyAway==false)){
                        if ((Math.abs(blackDuck.x-blackDuck.targetX)<=blackDuck.epsilon)&&(blackDuck.y<=blackDuck.prevY)){
                            if (blackDuck.state!="TOP") {
                                blackDuck.state = "TOP"
                                blackDuck.currentFrame=blackDuck.startFrame
                            }
                        } else if ((Math.abs(blackDuck.x-blackDuck.targetX)<=blackDuck.epsilon)&&(blackDuck.y>=blackDuck.prevY)){
                            if (blackDuck.state!="DOWN") {
                                blackDuck.state = "DOWN"
                                blackDuck.currentFrame=blackDuck.startFrame
                            }
                        } else if (blackDuck.x>=blackDuck.prevX){
                            if (blackDuck.state!="TOP_RIGHT") {
                                blackDuck.state = "TOP_RIGHT"
                                blackDuck.currentFrame=blackDuck.startFrame
                            }
                        } else if (blackDuck.x<=blackDuck.prevX){
                            if (blackDuck.state!="TOP_LEFT") {
                                blackDuck.state = "TOP_LEFT"
                                blackDuck.currentFrame=blackDuck.startFrame
                            }
                        } else {
                            if (blackDuck.state!="TOP") {
                                blackDuck.state = "TOP"
                                blackDuck.currentFrame=blackDuck.startFrame
                            }
                        }

                        blackDuck.lifeTime++

                        if ((blackDuck.flyAway==false)&&((blackDuck.lifeTime>=Math.floor(duckMaxLifeTime/blackDuck.animationSpeed))||(gameStatistic.bullet==0))){
                            blackDuck.flyAway=true
                            blackDuck.state="TOP"
                            blackDuck.targetX=blackDuck.x
                            blackDuck.targetY=-100
                            blackDuck.prevSpeed=blackDuck.speed
                            blackDuck.prevAnimationSpeed=blackDuck.animationSpeed

                            blackDuckNeeded=false
                        }

                        if (Math.ceil((Math.floor(Math.abs(blackDuck.x-blackDuck.targetX)))<=blackDuck.epsilon)&&
                                (Math.ceil(Math.floor(Math.abs(blackDuck.y-blackDuck.targetY)))<=blackDuck.epsilon)){
                            blackDuck.targetX=10+Math.random()*800
                            blackDuck.targetY=10+Math.random()*350
                        }
                    }

                    if ((blackDuck.flyAway==true)&&(blackDuck.y<=-50)){
                        if ((!dogTimer.running)&&(!blackDuckNeeded)){
                            gameStatistic.miss++
                            blackDuck.visible=false
                            dog.state="MISS"
                            dog.animationSpeed=100
                            dog.currentFrame=dog.startFrame
                            dog.x=blackDuck.x
                            dog.y=380
                            dog.targetX=blackDuck.x
                            dog.targetY=270
                            chienCry.play()
                            initialDuck="BLACK_DUCK"
                            dogTimer.start()
                        }
                        if ((blackDuckNeeded)&&(gameStatistic.total>0)){
                            gameStatistic.total--
                            blackDuck.visible=true
                            blackDuck.state="TOP"
                            blackDuck.x=10+Math.random()*(gameScreen.width-10)
                            blackDuck.y=360
                            blackDuck.prevX=398
                            blackDuck.prevY=362
                            blackDuck.targetX= 10+Math.random()*800
                            blackDuck.targetY= 10+Math.random()*350

                            blackDuck.speed=blackDuck.prevSpeed
                            blackDuck.animationSpeed=blackDuck.prevAnimationSpeed

                            blackDuck.z=3
                            blackDuck.lifeTime=0
                            blackDuck.flyAway=false
                            duckFlightSound.play()
                        }
                    }

                    if ((blackDuck.state=="DEAD")&&(blackDuck.y>=378)){
                        if ((!dogTimer.running)&&(!blackDuckNeeded)){
                            canardSol.play()
                            blackDuck.visible=false
                            currentBonusBlackDuck.lifeTime=0
                            currentBonusBlackDuck.visible=false
                            dog.state="CATCH"
                            dog.animationSpeed=50
                            dog.currentFrame=dog.startFrame
                            dog.x=blackDuck.x-blackDuck.width/2
                            dog.y=380
                            dog.targetX=blackDuck.x-blackDuck.width/2
                            dog.targetY=270
                            chienRamasse.play()
                            initialDuck="BLACK_DUCK"
                            dogTimer.start()
                        }
                        if ((blackDuckNeeded)&&(gameStatistic.total>0)){
                            gameStatistic.total--
                            blackDuck.visible=true
                            blackDuck.state="TOP"
                            blackDuck.x=10+Math.random()*(gameScreen.width-10)
                            blackDuck.y=360
                            blackDuck.prevX=398
                            blackDuck.prevY=362
                            blackDuck.targetX= 10+Math.random()*800
                            blackDuck.targetY= 10+Math.random()*350

                            if (blackDuck.animationSpeed>20) blackDuck.animationSpeed=80-gameStatistic.level*10;
                            if (blackDuck.speed<8) blackDuck.speed=4+gameStatistic.level
                            if (blackDuck.speed<8) blackDuck.epsilon=10+gameStatistic.level

                            blackDuck.z=3
                            blackDuck.lifeTime=0
                            blackDuck.flyAway=false
                            duckFlightSound.play()
                        }
                    }

                    if (blackDuck.currentFrame==blackDuck.endFrame){
                        blackDuck.currentFrame=blackDuck.startFrame
                    } else {
                        blackDuck.currentFrame++
                    }

                    blackDuck.z=3
                }
            }
        }

        Timer{
            id:brownDuckTimer
            interval:brownDuck.animationSpeed
            running:false
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    brownDuck.prevX=brownDuck.x
                    brownDuck.prevY=brownDuck.y

                    brownDuck.x+=Math.ceil(((brownDuck.targetX-brownDuck.x)/Math.abs(brownDuck.targetX-brownDuck.x))*brownDuck.speed)
                    brownDuck.y+=Math.ceil(((brownDuck.targetY-brownDuck.y)/Math.abs(brownDuck.targetY-brownDuck.y))*brownDuck.speed)

                    if ((brownDuck.state!="DEAD")&&(brownDuck.flyAway==false)){
                        if ((Math.abs(brownDuck.x-brownDuck.targetX)<=brownDuck.epsilon)&&(brownDuck.y<=brownDuck.prevY)){
                            if (brownDuck.state!="TOP") {
                                brownDuck.state = "TOP"
                                brownDuck.currentFrame=brownDuck.startFrame
                            }
                        } else if ((Math.abs(brownDuck.x-brownDuck.targetX)<=brownDuck.epsilon)&&(brownDuck.y>=brownDuck.prevY)){
                            if (brownDuck.state!="DOWN") {
                                brownDuck.state = "DOWN"
                                brownDuck.currentFrame=brownDuck.startFrame
                            }
                        } else if (brownDuck.x>=brownDuck.prevX){
                            if (brownDuck.state!="TOP_RIGHT") {
                                brownDuck.state = "TOP_RIGHT"
                                brownDuck.currentFrame=brownDuck.startFrame
                            }
                        } else if (brownDuck.x<=brownDuck.prevX){
                            if (brownDuck.state!="TOP_LEFT") {
                                brownDuck.state = "TOP_LEFT"
                                brownDuck.currentFrame=brownDuck.startFrame
                            }
                        } else {
                            if (brownDuck.state!="TOP") {
                                brownDuck.state = "TOP"
                                brownDuck.currentFrame=brownDuck.startFrame
                            }
                        }

                        brownDuck.lifeTime++

                        if ((brownDuck.flyAway==false)&&((brownDuck.lifeTime>=Math.floor(duckMaxLifeTime/brownDuck.animationSpeed))||(gameStatistic.bullet==0))){
                            brownDuck.flyAway=true
                            brownDuck.state="TOP"
                            brownDuck.targetX=brownDuck.x
                            brownDuck.targetY=-100
                            brownDuck.prevSpeed=brownDuck.speed
                            brownDuck.prevAnimationSpeed=brownDuck.animationSpeed

                            brownDuckNeeded=false
                        }

                        if (Math.ceil((Math.floor(Math.abs(brownDuck.x-brownDuck.targetX)))<=brownDuck.epsilon)&&
                                (Math.ceil(Math.floor(Math.abs(brownDuck.y-brownDuck.targetY)))<=brownDuck.epsilon)){
                            brownDuck.targetX=10+Math.random()*800
                            brownDuck.targetY=10+Math.random()*350
                        }

                    }

                    if ((brownDuck.flyAway==true)&&(brownDuck.y<=-50)){
                        if ((!dogTimer.running)&&(!brownDuckNeeded)){
                            gameStatistic.miss++
                            brownDuck.visible=false
                            dog.state="MISS"
                            dog.animationSpeed=60
                            dog.currentFrame=dog.startFrame
                            dog.x=brownDuck.x
                            dog.y=380
                            dog.targetX=brownDuck.x
                            dog.targetY=270
                            chienCry.play()
                            initialDuck="BROWN_DUCK"
                            dogTimer.start()
                        }
                        if ((brownDuckNeeded)&&(gameStatistic.total>0)){
                            gameStatistic.total--
                            brownDuck.visible=true
                            brownDuck.state="TOP"
                            brownDuck.x=10+Math.random()*(gameScreen.width-10)
                            brownDuck.y=360
                            brownDuck.prevX=398
                            brownDuck.prevY=362
                            brownDuck.targetX= 10+Math.random()*800
                            brownDuck.targetY= 10+Math.random()*350

                            brownDuck.speed=brownDuck.prevSpeed
                            brownDuck.animationSpeed=brownDuck.prevAnimationSpeed

                            brownDuck.z=3
                            brownDuck.lifeTime=0
                            brownDuck.flyAway=false
                            duckFlightSound.play()
                        }
                    }

                    if ((brownDuck.state=="DEAD")&&(brownDuck.y>=378)){
                        if ((!dogTimer.running)&&(!brownDuckNeeded)){
                            canardSol.play()
                            brownDuck.visible=false
                            currentBonusBrownDuck.lifeTime=0
                            currentBonusBrownDuck.visible=false
                            dog.state="CATCH"
                            dog.animationSpeed=50
                            dog.currentFrame=dog.startFrame
                            dog.x=brownDuck.x-brownDuck.width/2
                            dog.y=380
                            dog.targetX=brownDuck.x-brownDuck.width/2
                            dog.targetY=270
                            chienRamasse.play()
                            initialDuck="BROWN_DUCK"
                            dogTimer.start()
                        }

                        if ((brownDuckNeeded)&&(gameStatistic.total>0)){
                            gameStatistic.total--
                            brownDuck.visible=true
                            brownDuck.state="TOP"
                            brownDuck.x=10+Math.random()*(gameScreen.width-10)
                            brownDuck.y=360
                            brownDuck.prevX=398
                            brownDuck.prevY=362
                            brownDuck.targetX= 10+Math.random()*800
                            brownDuck.targetY= 10+Math.random()*350

                            if (brownDuck.animationSpeed>20) brownDuck.animationSpeed=80-gameStatistic.level*10;
                            if (brownDuck.speed<8) brownDuck.speed=4+gameStatistic.level
                            if (brownDuck.speed<8) brownDuck.epsilon=10+gameStatistic.level

                            brownDuck.z=3
                            brownDuck.lifeTime=0
                            brownDuck.flyAway=false
                            duckFlightSound.play()
                        }
                    }

                    if (brownDuck.currentFrame==brownDuck.endFrame){
                        brownDuck.currentFrame=brownDuck.startFrame
                    } else {
                        brownDuck.currentFrame++
                    }

                    brownDuck.z=3
                }
            }
        }

        Timer{
            id:greenDuckTimer
            interval:greenDuck.animationSpeed
            running:false
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    greenDuck.prevX=greenDuck.x
                    greenDuck.prevY=greenDuck.y

                    greenDuck.x+=Math.ceil(((greenDuck.targetX-greenDuck.x)/Math.abs(greenDuck.targetX-greenDuck.x))*greenDuck.speed)
                    greenDuck.y+=Math.ceil(((greenDuck.targetY-greenDuck.y)/Math.abs(greenDuck.targetY-greenDuck.y))*greenDuck.speed)

                    if ((greenDuck.state!="DEAD")&&(greenDuck.flyAway==false)){
                        if ((Math.abs(greenDuck.x-greenDuck.targetX)<=greenDuck.epsilon)&&(greenDuck.y<=greenDuck.prevY)){
                            if (greenDuck.state!="TOP") {
                                greenDuck.state = "TOP"
                                greenDuck.currentFrame=greenDuck.startFrame
                            }
                        } else if ((Math.abs(greenDuck.x-greenDuck.targetX)<=greenDuck.epsilon)&&(greenDuck.y>=greenDuck.prevY)){
                            if (greenDuck.state!="DOWN") {
                                greenDuck.state = "DOWN"
                                greenDuck.currentFrame=greenDuck.startFrame
                            }
                        } else if (greenDuck.x>=greenDuck.prevX){
                            if (greenDuck.state!="TOP_RIGHT") {
                                greenDuck.state = "TOP_RIGHT"
                                greenDuck.currentFrame=greenDuck.startFrame
                            }
                        } else if (greenDuck.x<=greenDuck.prevX){
                            if (greenDuck.state!="TOP_LEFT") {
                                greenDuck.state = "TOP_LEFT"
                                greenDuck.currentFrame=greenDuck.startFrame
                            }
                        } else {
                            if (greenDuck.state!="TOP") {
                                greenDuck.state = "TOP"
                                greenDuck.currentFrame=greenDuck.startFrame
                            }
                        }

                        greenDuck.lifeTime++

                        if ((greenDuck.flyAway==false)&&((greenDuck.lifeTime>=Math.floor(duckMaxLifeTime/greenDuck.animationSpeed))||(gameStatistic.bullet==0))){
                            greenDuck.flyAway=true
                            greenDuck.state="TOP"
                            greenDuck.targetX=greenDuck.x
                            greenDuck.targetY=-100
                            greenDuck.prevSpeed=greenDuck.speed
                            greenDuck.prevAnimationSpeed=greenDuck.animationSpeed

                            greenDuckNeeded=false
                        }

                        if (Math.ceil((Math.floor(Math.abs(greenDuck.x-greenDuck.targetX)))<=greenDuck.epsilon)&&
                                (Math.ceil(Math.floor(Math.abs(greenDuck.y-greenDuck.targetY)))<=greenDuck.epsilon)){
                            greenDuck.targetX=10+Math.random()*800
                            greenDuck.targetY=10+Math.random()*350
                        }

                    }

                    if ((greenDuck.flyAway==true)&&(greenDuck.y<=-50)){
                        if ((!dogTimer.running)&&(!greenDuckNeeded)){
                            gameStatistic.miss++
                            greenDuck.visible=false
                            dog.state="MISS"
                            dog.animationSpeed=60
                            dog.currentFrame=dog.startFrame
                            dog.x=greenDuck.x
                            dog.y=380
                            dog.targetX=greenDuck.x
                            dog.targetY=270
                            chienCry.play()
                            initialDuck="GREEN_DUCK"
                            dogTimer.start()
                        }
                        if ((greenDuckNeeded)&&(gameStatistic.total>0)){
                            gameStatistic.total--
                            greenDuck.visible=true
                            greenDuck.state="TOP"
                            greenDuck.x=10+Math.random()*(gameScreen.width-10)
                            greenDuck.y=360
                            greenDuck.prevX=398
                            greenDuck.prevY=362
                            greenDuck.targetX= 10+Math.random()*800
                            greenDuck.targetY= 10+Math.random()*350

                            greenDuck.speed=greenDuck.prevSpeed
                            greenDuck.animationSpeed=greenDuck.prevAnimationSpeed

                            greenDuck.z=3
                            greenDuck.lifeTime=0
                            greenDuck.flyAway=false
                            duckFlightSound.play()
                        }
                    }

                    if ((greenDuck.state=="DEAD")&&(greenDuck.y>=378)){
                        if ((!dogTimer.running)&&(!greenDuckNeeded)){
                            canardSol.play()
                            greenDuck.visible=false
                            currentBonusGreenDuck.lifeTime=0
                            currentBonusGreenDuck.visible=false
                            dog.state="CATCH"
                            dog.animationSpeed=50
                            dog.currentFrame=dog.startFrame
                            dog.x=greenDuck.x-greenDuck.width/2
                            dog.y=380
                            dog.targetX=greenDuck.x-greenDuck.width/2
                            dog.targetY=270
                            chienRamasse.play()
                            initialDuck="GREEN_DUCK"
                            dogTimer.start()
                        }

                        if ((greenDuckNeeded)&&(gameStatistic.total>0)){
                            gameStatistic.total--
                            greenDuck.visible=true
                            greenDuck.state="TOP"
                            greenDuck.x=10+Math.random()*(gameScreen.width-10)
                            greenDuck.y=360
                            greenDuck.prevX=398
                            greenDuck.prevY=362
                            greenDuck.targetX= 10+Math.random()*800
                            greenDuck.targetY= 10+Math.random()*350

                            if (greenDuck.animationSpeed>20) greenDuck.animationSpeed=80-gameStatistic.level*10;
                            if (greenDuck.speed<8) greenDuck.speed=4+gameStatistic.level
                            if (greenDuck.speed<8) greenDuck.epsilon=10+gameStatistic.level

                            greenDuck.z=3
                            greenDuck.lifeTime=0
                            greenDuck.flyAway=false
                            duckFlightSound.play()
                        }
                    }

                    if (greenDuck.currentFrame==greenDuck.endFrame){
                        greenDuck.currentFrame=greenDuck.startFrame
                    } else {
                        greenDuck.currentFrame++
                    }

                    greenDuck.z=3
                }
            }
        }


        Timer{
            id:shotAnimationTimer
            interval:shot.animationSpeed
            running:false
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    shot.currentFrame++
                    if (shot.currentFrame==shot.framesCount){
                        shotAnimationTimer.stop()
                    }
                }
            }
        }




        MouseArea{
            id: gameScreenMouseArea
            property bool isKill: false

            anchors.fill: parent
            onPressed: {
                if ((!mainPage.paused)&&(dog.state!="START_LEVEL")&&(!initializationFlag)&&(!startMenu.visible)&&(!selectLevelMenu.visible)){
                    isKill=false
                    if (gameStatistic.bullet>0){
                        shot.x=mouseX-shot.width/2
                        shot.y=mouseY-shot.height/2
                        shot.currentFrame=0
                        shotAnimationTimer.start()
                        gameStatistic.bullet--

                        rumbleEffect.start();
                        shotSound.play();

                        if ((mouseX>blackDuck.x)&&(mouseX<(blackDuck.x+blackDuck.width))&&
                                (mouseY>blackDuck.y)&&(mouseY<(blackDuck.y+blackDuck.height))){
                            gameStatistic.kill++

                            currentBonusBlackDuck.centerX=blackDuck.x+blackDuck.width/2
                            currentBonusBlackDuck.centerY=blackDuck.y+blackDuck.height/2
                            currentBonusBlackDuck.targetValue=(10+gameStatistic.level*2)*gameStatistic.multiplier
                            currentBonusBlackDuck.lifeTime=currentBonusBlackDuck.targetValue+5

                            blackDuck.state = "DEAD"
                            duckDeadSound.play()
                            blackDuck.targetX=blackDuck.x
                            blackDuck.targetY=400
                            blackDuckNeeded=false

                            blackDuck.prevSpeed=blackDuck.speed
                            blackDuck.prevAnimationSpeed=blackDuck.animationSpeed
                            blackDuck.speed=5
                            blackDuck.animationSpeed=50

                            feathers1.x=blackDuck.x-70
                            feathers1.y=blackDuck.y-70

                            feathers1.targetX=blackDuck.x
                            feathers1.targetY=500
                            feathers1.state="START"
                            feathers1.currentFrame=-1
                            feathers1.opacity=1
                            feathers1.visible=true
                            featherTimer.start()

                            isKill=true
                        }

                        if ((mouseX>brownDuck.x)&&(mouseX<(brownDuck.x+brownDuck.width))&&
                                (mouseY>brownDuck.y)&&(mouseY<(brownDuck.y+brownDuck.height))){
                            gameStatistic.kill++

                            currentBonusBrownDuck.centerX=brownDuck.x+brownDuck.width/2
                            currentBonusBrownDuck.centerY=brownDuck.y+brownDuck.height/2
                            currentBonusBrownDuck.targetValue=(10+gameStatistic.level*2)*gameStatistic.multiplier
                            currentBonusBrownDuck.lifeTime=currentBonusBrownDuck.targetValue+5

                            brownDuck.state = "DEAD"
                            duckDeadSound.play()
                            brownDuck.targetX=brownDuck.x
                            brownDuck.targetY=400
                            brownDuckNeeded=false

                            brownDuck.prevSpeed=brownDuck.speed
                            brownDuck.prevAnimationSpeed=brownDuck.animationSpeed
                            brownDuck.speed=5
                            brownDuck.animationSpeed=50

                            feathers2.x=brownDuck.x-70
                            feathers2.y=brownDuck.y-70

                            feathers2.targetX=brownDuck.x
                            feathers2.targetY=500
                            feathers2.state="START"
                            feathers2.currentFrame=-1
                            feathers2.opacity=1
                            feathers2.visible=true
                            featherTimer2.start()

                            isKill=true
                        }

                        if ((mouseX>greenDuck.x)&&(mouseX<(greenDuck.x+greenDuck.width))&&
                                (mouseY>greenDuck.y)&&(mouseY<(greenDuck.y+greenDuck.height))){
                            gameStatistic.kill++

                            currentBonusGreenDuck.centerX=greenDuck.x+greenDuck.width/2
                            currentBonusGreenDuck.centerY=greenDuck.y+greenDuck.height/2
                            currentBonusGreenDuck.targetValue=(10+gameStatistic.level*2)*gameStatistic.multiplier
                            currentBonusGreenDuck.lifeTime=currentBonusGreenDuck.targetValue+5

                            greenDuck.state = "DEAD"
                            duckDeadSound.play()
                            greenDuck.targetX=greenDuck.x
                            greenDuck.targetY=400
                            greenDuckNeeded=false

                            greenDuck.prevSpeed=greenDuck.speed
                            greenDuck.prevAnimationSpeed=greenDuck.animationSpeed
                            greenDuck.speed=5
                            greenDuck.animationSpeed=50

                            feathers3.x=greenDuck.x-70
                            feathers3.y=greenDuck.y-70

                            feathers3.targetX=greenDuck.x
                            feathers3.targetY=500
                            feathers3.state="START"
                            feathers3.currentFrame=-1
                            feathers3.opacity=1
                            feathers3.visible=true
                            featherTimer3.start()

                            isKill=true
                        }
                    } else {
                        fireSound.play()
                    }


                    if (isKill==true){
                        gameStatistic.series++
                        if ((gameStatistic.series==3)||(gameStatistic.series==6)||(gameStatistic.series==9)||(gameStatistic.series==12)||(gameStatistic.series==15)) gameStatistic.multiplier++
                    } else{
                        gameStatistic.series=0
                        gameStatistic.multiplier=1
                    }
                }
            }
        }

        ////////////////////////////////////////
        Text{
            property bool up: true
            id: multiplierText
            x: 400
            y: 5
            z: 100
            color: "white"
            font.pixelSize: 20
            text: "X "+gameStatistic.multiplier
            opacity: 0.6
            visible: false
        }

        Bonus{
            id: currentBonusBlackDuck
            visible: false
        }

        Timer{
            id:multiplierTextTimer
            interval: 60
            running:true
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    if (gameStatistic.multiplier>1){
                        multiplierText.visible=true
                        if (multiplierText.up) {
                            multiplierText.y++
                            multiplierText.x--
                            multiplierText.font.pixelSize=multiplierText.font.pixelSize+2
                            if (multiplierText.font.pixelSize>40) multiplierText.up=false
                        } else{
                            multiplierText.y--
                            multiplierText.x++
                            multiplierText.font.pixelSize=multiplierText.font.pixelSize-2
                            if (multiplierText.font.pixelSize<30) multiplierText.up=true
                        }
                    } else{
                        multiplierText.visible=false
                        multiplierText.font.pixelSize=30
                        multiplierText.up=true
                        multiplierText.x=400
                        multiplierText.y=5
                    }
                }
            }
        }

        Timer{
            id:currentBonusBlackDuckTimer
            interval: 60*1/(gameStatistic.multiplier*(gameStatistic.level+1))
            running:true
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    if (currentBonusBlackDuck.lifeTime>0)
                    {
                        currentBonusBlackDuck.visible=true
                        currentBonusBlackDuck.lifeTime--
                        if (currentBonusBlackDuck.currentValue<currentBonusBlackDuck.targetValue) {
                            if (currentBonusBlackDuck.currentValue+gameStatistic.multiplier<currentBonusBlackDuck.targetValue){
                                currentBonusBlackDuck.currentValue=currentBonusBlackDuck.currentValue+gameStatistic.multiplier
                                gameStatistic.levelScore=gameStatistic.levelScore+gameStatistic.multiplier
                            } else {
                                currentBonusBlackDuck.currentValue=currentBonusBlackDuck.currentValue+1
                                gameStatistic.levelScore=gameStatistic.levelScore+1
                            }
                        }

                        currentBonusBlackDuck.textPosX++
                        currentBonusBlackDuck.duckPosX=blackDuck.x+blackDuck.width-currentBonusBlackDuck.centerX
                        currentBonusBlackDuck.duckPosY=blackDuck.y+blackDuck.height-currentBonusBlackDuck.centerY
                    }
                    else{
                        currentBonusBlackDuck.visible=false
                        currentBonusBlackDuck.textPosX=80
                        currentBonusBlackDuck.currentValue=0
                    }
                }
            }
        }

        Bonus{
            id: currentBonusBrownDuck
            visible: false
        }

        Timer{
            id:currentBonusBrownDuckTimer
            interval: 60*1/(gameStatistic.multiplier*(gameStatistic.level+1))
            running:true
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    if (currentBonusBrownDuck.lifeTime>0)
                    {
                        currentBonusBrownDuck.visible=true
                        currentBonusBrownDuck.lifeTime--
                        if (currentBonusBrownDuck.currentValue<currentBonusBrownDuck.targetValue) {
                            if (currentBonusBrownDuck.currentValue+gameStatistic.multiplier<currentBonusBrownDuck.targetValue){
                                currentBonusBrownDuck.currentValue=currentBonusBrownDuck.currentValue+gameStatistic.multiplier
                                gameStatistic.levelScore=gameStatistic.levelScore+gameStatistic.multiplier
                            } else {
                                currentBonusBrownDuck.currentValue=currentBonusBrownDuck.currentValue+1
                                gameStatistic.levelScore=gameStatistic.levelScore+1
                            }
                        }
                        currentBonusBrownDuck.textPosX++
                        currentBonusBrownDuck.duckPosX=brownDuck.x+brownDuck.width-currentBonusBrownDuck.centerX
                        currentBonusBrownDuck.duckPosY=brownDuck.y+brownDuck.height-currentBonusBrownDuck.centerY
                    }
                    else{
                        currentBonusBrownDuck.visible=false
                        currentBonusBrownDuck.textPosX=80
                        currentBonusBrownDuck.currentValue=0
                    }
                }
            }
        }


        Bonus{
            id: currentBonusGreenDuck
            visible: false
        }

        Timer{
            id:currentBonusGreenDuckTimer
            interval: 60*1/(gameStatistic.multiplier*(gameStatistic.level+1))
            running:true
            repeat:true
            onTriggered:{
                if (!mainPage.paused){
                    if (currentBonusGreenDuck.lifeTime>0)
                    {
                        currentBonusGreenDuck.visible=true
                        currentBonusGreenDuck.lifeTime--
                        if (currentBonusGreenDuck.currentValue<currentBonusGreenDuck.targetValue) {
                            if (currentBonusGreenDuck.currentValue+gameStatistic.multiplier<currentBonusGreenDuck.targetValue){
                                currentBonusGreenDuck.currentValue=currentBonusGreenDuck.currentValue+gameStatistic.multiplier
                                gameStatistic.levelScore=gameStatistic.levelScore+gameStatistic.multiplier
                            } else {
                                currentBonusGreenDuck.currentValue=currentBonusGreenDuck.currentValue+1
                                gameStatistic.levelScore=gameStatistic.levelScore+1
                            }
                        }
                        currentBonusGreenDuck.textPosX++
                        currentBonusGreenDuck.duckPosX=greenDuck.x+greenDuck.width-currentBonusGreenDuck.centerX
                        currentBonusGreenDuck.duckPosY=greenDuck.y+greenDuck.height-currentBonusGreenDuck.centerY
                    }
                    else{
                        currentBonusGreenDuck.visible=false
                        currentBonusGreenDuck.textPosX=80
                        currentBonusGreenDuck.currentValue=0
                    }
                }
            }
        }
        /////////////////////////////////////////


        Rectangle{
            id: menuButton
            x: gameScreen.width-70
            y: gameScreen.height-70
            z: 100
            width: 60
            height: 60
            visible: ((!startMenu.visible)&&(!newLevelMenu.visible)&&(!gameOverMenu.visible))
            opacity: 0.85
            radius: 15

            Image{
                source: "MEDIA/GFX/menu/menuButton.png"
                anchors.centerIn: parent
                z: parent.z+2
            }

            Gradient {
                id: gradientStandart
                GradientStop { position: 0.0; color: "#707070" }
                GradientStop { position: 0.2; color: "#606060" }
                GradientStop { position: 0.9;color: "#303030" }
                GradientStop { position: 1.0; color: "#202020" }
            }

            Gradient {
                id: gradientPressed
                GradientStop { position: 0.0; color: "#202020" }
                GradientStop { position: 0.2;color: "#303030" }
                GradientStop { position: 0.9; color: "#606060" }
                GradientStop { position: 1.0; color: "#707070" }
            }

            border.color: "black"
            gradient: gradientStandart

            MouseArea{
                anchors.fill:parent
                anchors.bottom: parent.bottom
                width:parent.width
                height: parent.height

                onPressed: menuButton.gradient=gradientPressed
                onReleased: menuButton.gradient=gradientStandart
                onClicked: {
                    gameOverTheme.stop()
                    newYorkTheme.stop()
                    goldenGateTheme.stop()
                    parisTheme.stop()
                    moscowTheme.stop()
                    chernobilTheme.stop()
                    egyptTheme.stop()
                    chinaTheme.stop()
                    startMenu.playButtonImage="MEDIA/GFX/menu/resumeButton.png"
                    menuButton.visible=false
                    startMenu.visible=true
                    mainPage.paused=true
                }
            }
        }

        Text{
            id: scorePanel
            x: 580
            y: 10
            z: 100
            font.pixelSize: 24
            color: "white"
            text: "Level score: "+gameStatistic.levelScore
            opacity: 1.0
        }

        /*Text{
            id: fpsPanel
            x: 20
            y: 10
            z: 100
            font.pixelSize: 24
            color: "white"
            text: "FPS: "+frameRate
            opacity: 1.0
        }*/

        /*Timer {
            interval: 1000
            running: true
            repeat: true

            onTriggered: frameRate = qmlViewer.getCurrentFPS()
        }*/

        SoundEffect  {
            id: fakeSoundEffect1
            volume: soundVolume
            source:"MEDIA/SND/fakeSoundEffect1.wav"
        }

        SoundEffect  {
            id: fakeSoundEffect2
            volume: soundVolume
            source:"MEDIA/SND/fakeSoundEffect2.wav"
        }

        SoundEffect  {
            id: fakeSoundEffect3
            volume: soundVolume
            source:"MEDIA/SND/fakeSoundEffect3.wav"
        }

        SoundEffect  {
            id: fakeSoundEffect4
            volume: soundVolume
            source:"MEDIA/SND/fakeSoundEffect4.wav"
        }

        SoundEffect  {
            id: gameOverTheme
            volume: soundVolume
            source:"MEDIA/SND/gameOver.wav"
        }

        SoundEffect  {
            id: chienSaute
            volume: soundVolume
            source:"MEDIA/SND/chienSaute.wav"
        }

        SoundEffect  {
            id: fireSound
            volume: soundVolume
            source:"MEDIA/SND/fire.wav"
        }

        SoundEffect  {
            id: duckFlightSound
            loops: 3
            volume: soundVolume
            source:"MEDIA/SND/flight.wav"
        }

        SoundEffect  {
            id: duckDeadSound
            volume: soundVolume
            source:"MEDIA/SND/dead.wav"
        }

        SoundEffect  {
            id: canardSol
            volume: soundVolume
            source:"MEDIA/SND/canardSol.wav"
        }

        SoundEffect  {
            id: chienRamasse
            volume: soundVolume
            source:"MEDIA/SND/chienRamasse.wav"
        }

        SoundEffect  {
            id: chienMarche
            volume: soundVolume
            source:"MEDIA/SND/chienMarche.wav"
        }

        SoundEffect  {
            id: chienCry
            volume: soundVolume
            source:"MEDIA/SND/chienCry.wav"
        }

        SoundEffect  {
            id: shotSound
            volume: soundVolume
            source:"MEDIA/SND/shot.wav"
        }

    }

    LevelCompleted{
        id: newLevelMenu
        visible: false
    }

    GameOver{
        id: gameOverMenu
        visible: false
    }

    Timer{
        id:mainGameCycle
        interval:100
        running:true
        repeat:true
        onTriggered:{
            if (initializationFlag)
            {
                //screen.setAllowedOrientations(Screen.Landscape)
                mainPage.paused=true
                startMenu.playButtonImage="MEDIA/GFX/menu/startNewGameButton.png"
                ifOldGameExist();
                startMenu.visible=true

                gameStatistic.score=0
                gameStatistic.level=1
                gameStatistic.total=10
                gameStatistic.kill=0
                gameStatistic.miss=0
                gameStatistic.bullet=13

                blackDuck.animationSpeed=100
                blackDuck.speed=5
                blackDuck.epsilon=10
                brownDuck.animationSpeed=100
                brownDuck.speed=5
                brownDuck.epsilon=10
                greenDuck.animationSpeed=100
                greenDuck.speed=5
                greenDuck.epsilon=10

                blackDuck.visible=false
                brownDuck.visible=false
                greenDuck.visible=false


                shotSound.stop()
                fireSound.stop()
                duckFlightSound.stop()
                duckDeadSound.stop()
                canardSol.stop()
                chienRamasse.stop()
                chienMarche.stop()
                chienSaute.stop()
                chienCry.stop()
                gameOverTheme.stop()

                initializationFlag=false
            }
            if (((gameStatistic.kill+gameStatistic.miss)>=gameStatistic.ducksTotal)&&(!mainPage.paused)&&(!blackDuck.visible)&&(!brownDuck.visible)&&(!greenDuck.visible)){
                if (gameStatistic.miss<=3){
                    gameStatistic.total=0
                    mainPage.paused=true

                    gameOverTheme.stop()
                    newYorkTheme.stop()
                    goldenGateTheme.stop()
                    parisTheme.stop()
                    moscowTheme.stop()
                    chernobilTheme.stop()
                    egyptTheme.stop()
                    chinaTheme.stop()

                    newLevelMenu.visible=true

                    blackDuck.visible=false
                    brownDuck.visible=false
                    greenDuck.visible=false
                } else {
                    gameStatistic.total=0
                    mainPage.paused=true
                    gameOverMenu.visible=true
                    gameStarted=false

                    gameOverTheme.stop()
                    newYorkTheme.stop()
                    goldenGateTheme.stop()
                    parisTheme.stop()
                    moscowTheme.stop()
                    chernobilTheme.stop()
                    egyptTheme.stop()
                    chinaTheme.stop()

                    gameOverTheme.play()

                    blackDuck.visible=false
                    brownDuck.visible=false
                    greenDuck.visible=false
                }
            }
            if ((!Qt.application.active)&&(gameStarted)){
                shotSound.stop()
                fireSound.stop()
                duckFlightSound.stop()
                duckDeadSound.stop()
                canardSol.stop()
                chienRamasse.stop()
                chienMarche.stop()
                chienSaute.stop()
                chienCry.stop()

                gameOverTheme.stop()

                if (gameScreen.state=="LEVEL1"){
                    newYorkTheme.pause()
                } else if (gameScreen.state=="LEVEL2"){
                    goldenGateTheme.pause()
                } else if (gameScreen.state=="LEVEL3"){
                    parisTheme.pause()
                } else if (gameScreen.state=="LEVEL4"){
                    moscowTheme.pause()
                }  else if (gameScreen.state=="LEVEL5"){
                    chernobilTheme.pause()
                }  else if (gameScreen.state=="LEVEL6"){
                    egyptTheme.pause()
                } else if (gameScreen.state=="LEVEL7"){
                    chinaTheme.pause()
                }

                startMenu.playButtonImage="MEDIA/GFX/menu/resumeButton.png"
                startMenu.visible=true
                mainPage.paused=true
            }
        }
    }

    FileIO {
        id: confFile
        source: iniFilePath
        onError: console.log(msg)
    }

    function ifOldGameExist(){
        if (!confFile.openFile()) return;
        confFile.readLine();
        if (confFile.readLine()>0) {gameStatistic.oldGameExist=true} else {gameStatistic.oldGameExist=false};
        confFile.closeFile();
    }
}
