import QtQuick 1.0

Rectangle {
    id: unlockMenu

    property int levelToUnlock: 0
    property int scoresToUnlock: 0

    x:parent.width/2-200
    y:parent.height/2-100
    z:100

    width: 400
    height: 200

    opacity: 0.9
    color: "#404040"
    radius: 10
    visible: false
    border.color: "black"

    Text{
        y: 20
        anchors.horizontalCenter: parent.horizontalCenter
        font.pixelSize: 30
        color: "white"
        text: "Unlock this level ?"
    }

    Text{
        y: 60
        anchors.horizontalCenter: parent.horizontalCenter
        font.pixelSize: 30
        color: "white"
        text: "Need scores: "+scoresToUnlock
    }

    Gradient {
        id: gradientStandart
        GradientStop { position: 0.0; color: "#707070" }
        GradientStop { position: 0.2; color: "#606060" }
        GradientStop { position: 0.9;color: "#303030" }
        GradientStop { position: 1.0; color: "#202020" }
    }

    Gradient {
        id: gradientPressed
        GradientStop { position: 0.0; color: "#202020" }
        GradientStop { position: 0.2;color: "#303030" }
        GradientStop { position: 0.9; color: "#606060" }
        GradientStop { position: 1.0; color: "#707070" }
    }

    Rectangle{
        id: okButton
        x: 20
        y: 120
        z: parent.z+1
        width: 160
        height: 60
        visible: parent.visible
        radius: 10

        Text{
            anchors.verticalCenter: parent.verticalCenter
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 40
            color: "white"
            text: "YES"
        }

        border.color: "black"
        gradient: gradientStandart

        MouseArea{
            anchors.fill:parent
            anchors.bottom: parent.bottom
            width:parent.width
            height: parent.height

            onPressed:  okButton.gradient=gradientPressed
            onReleased: okButton.gradient=gradientStandart
            onClicked: {
                gameStatistic.score=gameStatistic.score-scoresToUnlock

                var temp3 = gameStatistic.levelUnlocked
                temp3[levelToUnlock*3]=true
                gameStatistic.levelUnlocked=temp3

                unlockLevelMenu.visible=false
                selectLevelMenu.enabled=true
            }
        }
    }


    Rectangle{
        id: cancelButton
        x: 220
        y: 120
        z: parent.z+1
        width: 160
        height: 60
        visible: parent.visible
        radius: 10

        Text{
            anchors.verticalCenter: parent.verticalCenter
            anchors.horizontalCenter: parent.horizontalCenter
            font.pixelSize: 40
            color: "white"
            text: "NO"
        }

        border.color: "black"
        gradient: gradientStandart

        MouseArea{
            anchors.fill:parent
            anchors.bottom: parent.bottom
            width:parent.width
            height: parent.height

            onPressed:  cancelButton.gradient=gradientPressed
            onReleased: cancelButton.gradient=gradientStandart
            onClicked: {
                unlockLevelMenu.visible=false
                selectLevelMenu.enabled=true
            }
        }
    }

}

